\documentclass[unicode,pdftex,a5paper]{article}

%%%%%%%%%%%%%%%%%
% ((( preamble
%%%%%%%%%%%%%%%%%

\usepackage[T2A]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage{cmap}
\usepackage[margin=12mm,headsep=5pt,nomarginpar]{geometry}
\setlength{\footskip}{3.60004pt}
\usepackage[bookmarksopen=true]{hyperref}
\usepackage[all]{hypcap}

\usepackage[english,russian]{babel}

\usepackage{amsmath}
\usepackage{float}

\usepackage{fancyhdr}
\pagestyle{fancy}
\fancyhead{}
\fancyhead[C]{\thepage}
\fancyfoot{}
\renewcommand{\headrulewidth}{0pt}
\renewcommand{\footrulewidth}{0pt}

\usepackage{amsthm}

\newtheorem{theorem}{Theorem}

\floatstyle{boxed}
\restylefloat{figure}

%\usepackage{showframe}

%%%%%%%%%%%%%%%%%
% ))) preamble
%%%%%%%%%%%%%%%%%


\begin{document}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ((( Title page and annotations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\hypersetup{
pdftitle={MRSC: a toolkit for building multi-result supercompilers},
pdfauthor={Ilya G. Klyuchnikov, Sergei A. Romanenko},
pdfkeywords={supercompilation, program analysis, program
             transformation, domain-specific supercompilation},
}
%%%%%%%%%%%%%%%%%%%%%%
% THE FIRST TITLE PAGE
%%%%%%%%%%%%%%%%%%%%%%

\begin{titlepage}
\begin{center}
% {\Large
\textbf{KELDYSH INSTITUTE OF APPLIED MATHEMATICS}\\
\textbf{Russian Academy of Sciences}
% }
\end{center}
\null
\vfill\vfill
\normalfont
\begin{center}
% {\LARGE
\textbf{Ilya G. Klyuchnikov, Sergei A. Romanenko}
% }
\end{center}
\vspace{2mm}
\begin{center}
% {\Huge
\textbf{MRSC: a toolkit for building multi-result supercompilers}
% }
\end{center}
\vfill\vfill\vfill
\null
\begin{center}
\textbf{Moscow\\2011}
\end{center}
\end{titlepage}

\pagebreak

\begin{titlepage}
\setcounter{page}{2}
\noindent
\textbf{Ilya G. Klyuchnikov, Sergei A. Romanenko. MRSC: a toolkit for building
multi-result supercompilers}

\medskip\noindent
The paper explains the principles of multi-result supercompilation. We
introduce a formalism for representing supercompilation algorithms as rewriting
rules for graphs of configurations. Some low-level technical details related to
the implementation of multi-result supercompilation in MRSC are
discussed. In particular, we consider the advantages of using spaghetti stacks for
representing graphs of configurations.

\medskip\noindent
Supported by Russian Foundation for Basic Research project
No.~99-99-99999-a.

\vspace{3ex}

\selectlanguage{russian}
\bigskip\noindent
\textbf{И.Г. Ключников, С.А. Романенко. MRSC: инструментарий для создания
многорезультатных суперкомпиляторов}

\medskip\noindent
В работе рассматриваются принципы многорезультатной суперкомпиляции. Вводится
формализм для представления алгоритмов суперкомпиляции в виде правил
переписываний графа конфигураций. Разбираются технические детали поддержки
многорезультатной суперкомпиляции в инструментарии MRSC. Особое внимание
уделяется представлению графов конфигураций в виде спагетти-стеков.

\medskip\noindent
Работа выполнена при поддержке проекта РФФИ
№~99-99-99999-a.
\vfill\vfill\vfill
\selectlanguage{english}
\end{titlepage}

%%%%%%%%%%%%%%%%%
% ))) Title page
%%%%%%%%%%%%%%%%%

\setcounter{page}{3}
% %\selectlanguage{russian}
\selectlanguage{english}
\tableofcontents

\section{Introduction}
\label{section:introduction}

\subsection{Growing variety in the field of supercompilation}

\emph{Supercompilation} is a program manipulation technique that was originally
introduced by V. Turchin in terms of the programming language Refal (a
first-order applicative functional language) \cite{Turchin1986Supercompiler},
for which reason the first supercompilers were designed and developed for the
language Refal \cite{Turchin1979ScpSystem,Turchin1982Experiments,Nemytykh1996ProgTrans}.

\section{Schemes of traditional supercompilation}
\label{section:supercompilation_schemes}

In the supercompilation community, there are two well-established approaches to
describing and implementing supercompilers.

The first approach formulates supercompilation in terms of the construction of a
graph of configurations that is then transformed (residuated) into an output
(residual) program
\cite{Turchin1979ScpSystem,Sorensen1994TurchinSupercompiler,Sorensen1996Positive,Klyuchnikov2009SPSC,Klyuchnikov2009HOSC,Hamiltion2010Graph}.
The origin of this approach goes back to V. Turchin
\cite{Turchin1986Supercompiler}.

\begin{sloppypar}
The second approach considers a supercompiler as an expression transformer that
produces output programs ``directly'', avoiding the construction of intermediate
data structures (graphs of configurations)\footnote{At least in an explicit
way.}.
\end{sloppypar}

\section{Conclusion}
\label{section:conclusion}

This preprint describes only the internal structure and technical design of the
MRSC core. Next preprints will present concrete examples of rapid prototyping of
supercompilers by means of MRSC and the use of MRSC for implementing
domain-specific supercompilers.


\section*{Acknowledgements}
The authors express their gratitude to all participants of
Refal seminar at Keldysh Institute for useful comments and fruitful discussions
of this work.

%\pagebreak
\phantomsection % Ensures that a PDF bookmark is set here
\addcontentsline{toc}{section}{References}
\selectlanguage{english}
\bibliographystyle{abbrv}
%\bibliographystyle{ugost2008s}

\bibliography{refs}

\end{document}
